      integer j, Nr, iterc, convg, inform, nrmax,iterma
      parameter( iterma = 1000 )
      parameter( nrmax = 1 000 000 )
      complex*16 i
      parameter( i = (0.0, 1.0) )
      real*8     P(nrmax), PU(nrmax), PL(nrmax), B(nrmax)
      complex*16 D(nrmax), DU(nrmax), DL(nrmax), F(nrmax)
      complex*16 psi_n(nrmax), psi_np1(nrmax)
      real*8 Vnp1(nrmax)
      real*8 invert
      Nr = g1_Nr
      iterc = 1
      convg = 0
      inform = 0

       write(0,*) "epsiter is",epsiter
       write(0,*) "dr is ",dr
c      write(0,*) "dt is ",dt
c--------------------------------------------
c Define psi
c--------------------------------------------
      do j = 1, Nr
         psi_n(j) = phi_n(j) + i*pi_n(j)
      end do
c--------------------------------------------
c Define B
c--------------------------------------------
      do j = 1, Nr - 2
         B(j) = psi_n(j+1)*conjg(psi_n(j+1))
      end do
         B(Nr-1) = 0
c      write(0,*) 'B Defined'
c-------------------------------------------
c Initialization of V
c-------------------------------------------
      if ( vpass .eq. 1 ) then
      call vsxynt('Bo',t,r(2),B,Nr-1)

c      write(0,*) 'Initializing V'
c--------------------------------------------
cDefine diagonal, superdiagonal, & subdiagonal
c--------------------------------------------
c      write(0,*) 'Defining D, DL, DU'
      do j = 1, Nr-2
         P(j) = (-2.0d0)/(dr**2)
      end do 
         P(Nr-1) = 1.0d0

      do j = 2, Nr-2
         PU(j) = (1.0d0 + dr/r(j+1))/(dr**2)
      end do
         PU(1) = (4.0/(3.0*dr**2))
      do j = 1, Nr-3
         PL(j) = (1.0d0 - dr/r(j+2))/(dr**2)
      end do
         PL(Nr-2) = 0
c      write(0,*) 'PL,PU,P Defined'
c      write(0,*) PL
c      write(0,*) PU
c      write(0,*) P
c---------------------------------------------
c Call LAPACK to initialize V
c---------------------------------------------
c        write(0,*) 'Calling DGTSV to solve initial V'

         call DGTSV( Nr-1, 1, PL, P, PU, B, Nr-1, inform )
c         write(0,*) 'INFO =', inform
c         write(0,*) 'Initial V solved'
c         write(0,*) 'DGTSV output:'
c         write(0,*) PL
c         write(0,*) PU
c         write(0,*) P

         do j = 2, Nr
            V_n(j)   = B(j-1)
c            write(0,*) V_np1(j)
c            write(0,*) dr
         end do
            V_n(1) = (4.0/3.0)*V_n(2) - (1.0/3.0)*V_n(3)
c            write(0,*) V_n(1)

c         write(0,*) 'Initialization of V complete'     
      call vsxynt('Vo',t,r,V_n,Nr)
      end if

      if ( vpass .eq. 0 ) then
c       write(0,*) 'Begin update of psi, V'
c------------------------------------------------------------
c Initially set advanced time level to retarted time level
c---------------------------------------------------------
      do j = 1,Nr
         Vnp1(j)   = V_n(j)
c         write(0,*) Vnp1(j)
      end do
       call vsxynt('V_nstart',t,r,V_n,Nr)
       call vsxynt('Vnp1start',t,r,Vnp1,Nr)
       call vsxynt('V_np1start',t,r,V_np1,Nr)

c---------------------------------------------
c Main update loop
c---------------------------------------------
      do while ( ( convg .LE. Nr ) .AND. ( iterc .LT. iterma ) )
c       call vsxynt('V_nstart',t,r,V_n,Nr)
c       call vsxynt('Vnp1start',t,r,Vnp1,Nr)
c       call vsxynt('V_np1start',t,r,V_np1,Nr)
       convg = 0
       inform = 0
c      write(0,*) 'Main Loop Begin'
c---------------------------------------------
c Setup Intermediate variables for convergence checking
c---------------------------------------------
c     write(0,*) 'Solve psi holding Vnp1 constant'
c-------------------------------------------------------
c Calculate D, DU, DL, F for Psi
c-------------------------------------------------------
      do j = 1, Nr - 2
         D(j) = (i/dt - 0.5/(dr**2) - 0.5*Vnp1(j+1) )
      end do 
         D(Nr - 1) = 1.0d0

      do j = 2, Nr - 2
         DU(j) = (r(j+1) + dr)/(4.0*r(j+1)*dr**2)
      end do
         DU(1) = 0.5d0/(dr**2)

      do j = 1, Nr - 3
         DL(j) = (r(j+1) - dr)/(4.0*r(j+1)*dr**2)
      end do
         DL(Nr - 2) = 0

      do j = 2, Nr - 2
         F(j) = (i/dt)*psi_n(j+1) 
     &        - (psi_n(j+2) - psi_n(j))/(4*dr*r(j+1)) 
     &        - (psi_n(j+2) - 2.0*psi_n(j+1) + psi_n(j))/(4.0*dr**2)
     &        + 0.5*V_n(j+1)*psi_n(j+1)
      end do
         F(Nr-1) = 0
         F(1) = (psi_n(2)/dt) - (psi_n(3) - psi_n(2))/(2.0*dr**2)
     &         + 0.5*V_n(2)*psi_n(2)


         call ZGTSV( Nr-1, 1, DL, D, DU, F, Nr-1, inform )
c         write(0,*) 'Psi INFO=', inform   
c----------------------------------------------------------
c Send output to proper vectors
c----------------------------------------------------------
      do j = 2, Nr
         psi_np1(j) = F(j-1)
         phi_np1(j) = realpart(psi_np1(j))
          pi_np1(j) = imagpart(psi_np1(j))
      end do
         psi_np1(1) = (4.0*psi_np1(2) - psi_np1(3))/3.0
         phi_np1(1) = realpart(psi_np1(1))
          pi_np1(1) = imagpart(psi_np1(1))
c       call vsxynt('phi_iter',t,r,phi_np1,Nr)
c------------------------------------------------------
c      write(0,*) 'Determine B for calculation of V'
c------------------------------------------------------
      do j = 1, Nr - 2
         B(j) = psi_np1(j+1)*conjg(psi_np1(j+1))
      end do
        B(Nr-1) = 0
c       call vsxynt('Biter',t,r(2),B,Nr-1)      
c--------------------------------------------
cDefine diagonal, superdiagonal, & subdiagonal
c--------------------------------------------
c      write(0,*) 'Defining P, PL, PU
      do j = 1, Nr-2
         P(j) = (-2.0d0)/(dr**2)
      end do 
         P(Nr-1) = 1.0d0

      do j = 2, Nr-2
         PU(j) = (1.0d0 + dr/r(j+1))/(dr**2)
      end do
         PU(1) = (4.0/(3.0*dr**2))

      do j = 1, Nr-3
         PL(j) = (1.0d0 - dr/r(j+1))/(dr**2)
      end do
         PL(Nr-2) = 0
c      write(0,*) 'PL,PU,P Defined'

         call DGTSV( Nr-1, 1, PL, P, PU, B, Nr-1, inform )
c         write(0,*) 'V INFO =',inform
         do j = 2, Nr
            V_np1(j)   = B(j-1)
c            write(0,*) V_np1(j)
c            write(0,*) dr
         end do
            V_np1(1) = (4.0*V_np1(2) - V_np1(3))/3.0
c            write(0,*) V_np1(1)



c---------------------------------------------------------
c Check for convergence
c---------------------------------------------------------
c       write(0,*) 'Check for Convergence'
         do j = 1, Nr
            if ( DABS(V_np1(j) - Vnp1(j)) .LT. epsiter ) then
               convg = convg + 1
            end if
            if ( convg .eq. Nr ) then
             write(0,*) "V converged"
             convg = convg + 1
            end if
c            write(0,*) DABS(V_np1(j) - Vnp1(j))
         end do
c      write(0,*) 'Convergence test complete'
c      write(0,*) 'convg =', convg
c----------------------------------------------------------
c No convergence. Set counter variables
c---------------------------------------------------------
c      write(0,*) 'No convergence after ', iterc, ' iteration(s)'
c      convg = 0
      iterc = iterc + 1

      
      do j = 1,Nr
         Vnp1(j)   = V_np1(j)
      end do
        
      end do
      end if
